#ifndef _IMAGE_H
#define _IMAGE_H
#include "Pixel.h"
#include <iostream>

using namespace std;

class Image
{
private:
    unsigned dimx,dimy;
    Pixel * tab;
    

    public:
    Image();
    Image(int x, int y);
    ~Image();
    Pixel & getPix(int x, int y) const;
    Pixel getPix2(int x, int y) const;
    void setPix(int x, int y, Pixel couleur);
    void dessinerRectangle(int Xmin, int Ymin, int Xmax, int Ymax, Pixel couleur);
    void effacer (Pixel couleur);

    static void testRegression()
    {
        Pixel p;
        Pixel p2(10,20,30);    

        Image im(50,50);
        p = im.getPix2(20,26);
        cout<<p.r<<endl;
        cout<<endl;

        im.setPix(27,12,p2);
        Pixel p3 = im.getPix2(27,12);
        cout<<p3.r<<","<<p3.g<<","<<p3.b<<endl;
        cout<<endl;

        im.dessinerRectangle(10,10,30,30,Pixel(78,36,108));

        Pixel p4 = im.getPix2(15,20);
        cout<<p4.r<<","<<p4.g<<","<<p4.b<<endl;

        cout<<endl;

        im.effacer(Pixel(0,0,0));
        p4 = im.getPix2(18,25);
        cout<<p4.r<<","<<p4.g<<","<<p4.b<<endl;

    };

    void sauver(const string &filename) const;
    void ouvrir(const string &filename);
    void afficherConsole();
};

#endif


